package swtpl.marsrover.main;

import java.io.IOException;
import java.net.UnknownHostException;

import swtpl.marsrover.net.Connection;
import swtpl.marsrover.planner.JohoPlanner;

public class Main {

	public static void main(String[] args) {
		if( args.length != 2 ) {
			System.err.println("Usage: Main <hostname> <port>");
			System.exit(-1);
		}
		try {
			Connection con = new Connection(args[0],Integer.parseInt(args[1]));
			new JohoPlanner(con,null);
			con.startReading(con.getInputStream());
		} catch (UnknownHostException e) {
			e.printStackTrace(System.err);
		} catch (IOException e) {
			e.printStackTrace(System.err);
		}
	}

}
