package swtpl.marsrover.net;

public class VehicleEvent extends EventBase {
	public enum VehicleControlAcceleration {
		ACCELERATING,
		ROLLING,
		BRAKING
	}
	public enum VehicleControlTurning {
		HARDLEFT,
		LEFT,
		STRAIGHT,
		RIGHT,
		HARDRIGHT
	}
	
	public String toString() {
		return "VE["+mposX+","+mposY+"]";
	}
	
	private VehicleControlAcceleration mvca;
	private VehicleControlTurning mvct;
	private int mposX;
	private int mposY;
	private int mtenthdir;
	private int mspeed;
	public VehicleEvent(int timestamp,VehicleControlAcceleration vca,VehicleControlTurning vct,int posx,int posy,int tenthdir,int speed) {
		super(timestamp);
		mvca = vca;
		mvct = vct;
		mposX = posx;
		mposY = posy;
		mtenthdir = tenthdir;
		mspeed = speed;
	}
	public VehicleControlAcceleration getAccelerationState() {
		return mvca;
	}
	public VehicleControlTurning getTurningState() {
		return mvct;
	}
	// in mm
	public int getPosX() {
		return mposX;
	}
	// in mm
	public int getPosY() {
		return mposY;
	}
	// in tenth degrees
	public int getDir() {
		return mtenthdir;
	}
	// in mm per sec
	public int getSpeed() {
		return mspeed;
	}
	
}
