package swtpl.marsrover.planner;

public class DoubleLinkedList<E> {
	
	public Node head = null;
	public Node tail = null;
	
	//create a new node at the end of the list
	public void add(E o){
		addAfter(o, null);
	}
	
	public void addAfter(E o, Node n){
		Node newNode = new Node(o);
		if(head == null){ //empty list
			head = newNode;
			tail = newNode;
		}else if(n == null){ //insert as new head
			head.previous = newNode;
			newNode.next = head;
			head = newNode;
		}else if(tail == n){ //insert as new tail
			tail.next = newNode;
			newNode.previous = newNode;
			tail = newNode;
		}else{ //normal insertion
			newNode.next = n.next;
			n.next.previous = newNode;
			newNode.previous = n.previous;
			n.previous.next = newNode;
		}
	}
	
	public void delete(Node n){
		if(head == n){
			head = n.next;			
		}
		if(tail == n){
			tail = n.previous;
		}
		if(n.next != null){
			n.next.previous = n.previous;			
		}
		if(n.previous != null){
			n.previous.next = n.next;
		}
	}
		
	public class Node{
		public Node next = null;
		public Node previous = null;
		public E data;
		public Node(E data){
			this.data = data;
		}
	}
}