package utils;

import sun.reflect.generics.reflectiveObjects.NotImplementedException;

public class Metrics {
  
    static final double pid18 = Math.PI/1800.0;
  
	public static int normalizedAngle(int angle) {
		if (angle > 1800)
			return angle - 3600;
		if (angle < -1800)
			return angle + 3600;
		return angle;
	}
	
	public static long euklidDistSq(long dx, long dy) {
		return dx*dx + dy*dy;
	}
	
	public static long euklidDistSq(long sx, long sy,long dx, long dy) {
		dx-=sx;
		dy-=sy;
		return euklidDistSq(dx, dy);
	}
	
	public static long euklidDist(long dx, long dy) {
		return (long)Math.sqrt(euklidDistSq(dx,dy));
	}
	
	public static boolean inCircle(long radius, int relX, int relY) {
		return euklidDistSq(relX, relY) <= radius*radius;
	}
	
	public static int angleTowards(int sx, int sy, int dx, int dy) {
		return angle(dx-sx, dy-sy);
	}
	public static int angle(int x, int y) {
		return (int)(Math.atan2(y, x)/pid18);
	}
	
	public static int normalizedAngleTowards(int sx, int sy, int dx, int dy) {
		return normalizedAngle(angleTowards(sx, sy, dx, dy));
	}
	
	public static int scaledCos(double angle, double scale) {
		return (int)(Math.cos(angle*pid18)*scale);
	}
	
	public static int scaledSin(double angle, double scale) {
		return (int)(Math.sin(angle*pid18)*scale);
	}
	
	/* return the abs of the angle between the tangent from (sx,sy)
	 * on the circle at (dx,dy) with radius dr
	 * and the line through (sx,sy) and (dx,dy).
	 * it is the same for both tangents.
	 */
	public static int tangentAngleDiff(int sx, int sy, int dx, int dy, int dr) {
		throw new NotImplementedException();
	}
}
